// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cpm_ts_msgs:msg/CartesianAngleValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cpm_ts_msgs
const rosidl_type_hash_t *
etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x76, 0x06, 0xc9, 0x03, 0xb0, 0xf9, 0xf6, 0xcb,
      0x50, 0xe4, 0xd5, 0x86, 0x1a, 0x2e, 0xd5, 0x79,
      0x3c, 0x34, 0x9d, 0x35, 0xf8, 0x67, 0x63, 0xe0,
      0x08, 0xa4, 0xcc, 0x27, 0x08, 0x46, 0x03, 0x5b,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__TYPE_NAME[] = "etsi_its_cpm_ts_msgs/msg/CartesianAngleValue";

// Define type names, field names, and default values
static char etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__FIELDS[] = {
  {
    {etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__TYPE_NAME, 44, 44},
      {etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn\n"
  "#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cpm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in\n"
  "#  * a right-hand local coordinate system from the abscissa.\n"
  "#  *\n"
  "#  * The value shall be set to: \n"
  "#  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,\n"
  "#  * - `36001` if the accuracy information is not available.\n"
  "#  *\n"
  "#  * The value 3600 shall not be used. \n"
  "#  * \n"
  "#  * @unit 0,1 degrees\n"
  "#  * @category: Basic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# CartesianAngleValue ::= INTEGER {\n"
  "#     valueNotUsed (3600),\n"
  "#     unavailable  (3601)\n"
  "# } (0..3601)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 0\n"
  "uint16 MAX = 3601\n"
  "uint16 VALUE_NOT_USED = 3600\n"
  "uint16 UNAVAILABLE = 3601\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2917, 2917},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
